
#include "windows_compat.h"
#include "DefFile.h"

// Workaround (sonst Compilerfehler wegen Macro-Redefine)
#undef __NFDBITS
#undef __FDMASK

#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>


//***************************************************************************

CDefFile::CDefFile(void)
{
	//mhFile = NULL;
	mhFile = 0;
	mText  = NULL;
	mScan  = NULL;
}

//---------------------------------------------------------------------------

CDefFile::~CDefFile()
{
	Close();
}

//---------------------------------------------------------------------------

bool CDefFile::Open(char *fname)
{
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// open file ...
	TCHAR tname[32];
	C2T(tname, fname, sizeof(tname));

	mhFile = open(tname, O_RDONLY);
	if(mhFile < 0)
	{
		fprintf(stderr, "CDefFile: Error opening file %s\r\n", fname);
		mhFile = 0;
		return (false);
	}
/*
	mhFile = CreateFile(tname,					// Open file
						GENERIC_READ,			// Open for reading
						FILE_SHARE_READ,		// Share for reading
						NULL,					// No security
						OPEN_EXISTING,			// Existing file only
						FILE_ATTRIBUTE_NORMAL,	// Normal file
						NULL);					// No template file
	if (mhFile == INVALID_HANDLE_VALUE) {
		RETAILMSG(1, (TEXT("CDefFile: Error opening file %a\r\n"), fname));
		mhFile = NULL;
		return (false);
	}
*/

//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
// read file ...
	DWORD ilen, rlen;

	ilen = lseek(mhFile, 0, SEEK_END);
	if (ilen <= 0)
	{
		fprintf(stderr, "CDefFile: no file size %s\r\n", fname);
		Close();
		return false;
	}
	lseek(mhFile, 0, SEEK_SET);

/*	ilen = GetFileSize(mhFile, &ilen);
	if (!ilen) {
		RETAILMSG(1, (TEXT("CDefFile: no file size %a\r\n"), fname));
		Close();
		return (false);
	}
*/
	if (mText) delete mText;
	mText = new char[ilen];
	if (!mText) {
		fprintf(stderr, "CDefFile: Error getting mem for %s\r\n", fname);
		//RETAILMSG(1, (TEXT("CDefFile: Error getting mem for %a\r\n"), fname));
		Close();
		return (false);
	}

	rlen = read(mhFile, mText, ilen);
	if(rlen <= 0)
	{
		fprintf(stderr, "CDefFile: Error reading file %s\r\n", fname);
		perror("read");
		Close();
		return false;
	}
/*
	if (!ReadFile(mhFile, mText, ilen, &rlen, NULL)) {
		RETAILMSG(1, (TEXT("CDefFile: Error reading file %a\r\n"), fname));
		Close();
		return (false);
	}
*/
	mScan = mText;
	return (true);
}

//---------------------------------------------------------------------------

bool CDefFile::Close(void)
{
	//if (mhFile) CloseHandle(mhFile);	mhFile = NULL;
	if (mhFile) close(mhFile);			mhFile = 0;
	if (mText)  delete mText,			mText  = NULL;
	return (true);
}

//---------------------------------------------------------------------------

bool CDefFile::EoF(void)
{
	return (*mScan == 0);
}

//---------------------------------------------------------------------------

void CDefFile::skipLine(void)
// this skips to the char after a line feed
//	(it should be the only one that does so)
{
	char c;
	while ((c = *mScan))
	{
		mScan++;
		if (c == LF) break;
	}
}

//---------------------------------------------------------------------------

void CDefFile::skipWhite(void)
{
	char c;
	while ((c = *mScan))
	{
		if (c > ' ') break;
		if (c == CR) break;
		mScan++;
	}
}

//---------------------------------------------------------------------------

bool CDefFile::getWord(char *dp, short max)
{
	skipWhite();
	*dp = 0;
	char c = *mScan;
	if (!c) return (false);					// end of file
	max--;
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	if (c != '"') {
		while ((c = *mScan))
		{				// copy a word of non white chars
			if (!max--)   break;
			if (c <= ' ') break;
			*dp++ = c;
			mScan++;
		}
	}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	else {									// copy literal
		mScan++;							//	skip '"'
		while ((c = *mScan))
		{
			if (!max--)   break;
			if (c == '"') break;
			if (c == CR)  break;
			*dp++ = c;
			mScan++;
		}
	}
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	*dp = 0;								// terminate val string
	return (max > 0);
}

//---------------------------------------------------------------------------

bool CDefFile::getLine(char *dp, short max)
{
	*dp = 0;
	char c = *mScan;
	if (!c) return (false);					// end of file
	max--;
	while ((c = *mScan))
	{
		if (!max--)   break;
		if (c == CR)  break;
		*dp++ = c;
		mScan++;
	}
	*dp = 0;								// terminate string
	return (max > 0);
}

//***************************************************************************

