//////////////////////////////////////////////////////////////////////
//
// LBIND.h:  binding related routines
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
// Copyright (c) 1999  Gesytec GmbH
//
// Date:    7.01.00
//
// Author: mb, mboehlke@gesytec.de
//
//////////////////////////////////////////////////////////////////////

#ifndef LBIND_H
#define LBIND_H

#include "windows_compat.h"
#include "ni_host.h"
#include "ni_msg.h"

class CHANeuron;
class CXIF;

//---------------------------------------------------------------------------

class CBind 
{
public:
	CBind	(CHANeuron *host);		
	~CBind	(void);

	bool			ChkBinding		(void);

protected:
	bool			ReadBinding		(CXIF *xif);
	bool			InitBinding		(CXIF *xif);

	bool			ClrBinding		(CXIF *xif);
	BYTE			GetNodeState	(void);

	bool			bnd_readonly	(void);
	bool			ReadNVCfgs		(void);
	bool			WriteNVCfg		(short idx, nv_struct *pnvc);

protected:
	CHANeuron	*mHost;
	int			mNodeState;

	BYTE		*mSNVTlast;
	BYTE		*mSNVTmax;
	BYTE        mProgid[8];				// ProgramID
    short		mAdrtbl_anz;
};

//---------------------------------------------------------------------------
#endif // LBIND_H
