//////////////////////////////////////////////////////////////////////
//
// LHA.h:  interface to LON  Host Adapter Node
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
// Copyright (c) 1999  Gesytec GmbH
//
// Date:    7.01.00
//
// Author: mb, mboehlke@gesytec.de
//
//////////////////////////////////////////////////////////////////////

#ifndef G2LHA_H
#define G2LHA_H

#include "windows_compat.h"
#include "ni_privat.h"
#include "ni_host.h"
#include "LBIND.h"
#include "g2Lon.h"
#include <string.h>

//---------------------------------------------------------------------------

class CHANeuron : public CNeuron
{
public:
	CHANeuron				(NODE *node);				// create host
	~CHANeuron				(void);

	bool	ChkBinding		(void);
	bool	IsLHA			(void);

	DWORD	Receive			(void);
	bool	IncomingNV		(ExpAppBuf* buf, short len);
 	bool	IncomingMsg		(ExpAppBuf* buf, short len);

	bool	IncomingHostNV	(ExpAppBuf* buf);
	bool	FetchNV			(ExpAppBuf* buf);
	bool	QuerySNVT		(ExpAppBuf* buf);
	bool	QueryNVConfig	(ExpAppBuf* buf);
	bool	UpdNVConfig		(ExpAppBuf* buf);
	bool	SetNodeModeH	(ExpAppBuf* buf);

	bool	SendNV			(CNV *nv, BYTE *data);

 	short			GetNvIndex		(ExpAppBuf* buf);
	nv_fixed_struct	*GetNvFixed		(short idx);

friend class CBind;
protected:
	void	UpdNODE			(BYTE *pid);
	CNV		*AddNV			(char *name, char *selfdoc,
							 nv_fixed_struct  *pfix,
							 snvt_desc_struct *desc);

protected:
	CBind			*mBind;
	short			mNVanz;				// count of NVs
	WORD			mSnvtlen;			// length of snvt structures
	nv_fixed_struct	*mNvf;				// fixed struct
	BYTE			*mpSnvt;			// snvt structures
	BYTE			mMode;				//
	BYTE			mState;				//
	bool			mIsLHA;				// have a LHA node
};

//---------------------------------------------------------------------------
#endif // G2LHA_H
