#define	_H_NI_MSG_16				// Include this file only once
// Explicit message Application Buffer.

typedef struct {

// Header for network interface messages.  The header is a union of
// two command formats: the 'q' format is used for the niCOMM and
// niNETMGMT commands that require a queue specification; the 'noq'
// format is used for all other network interface commands.
// Both formats have a length specification where:
//
//  length = header (3) + address field (11) + data field

  union{
    struct {
    	unsigned char queue : 4;	// Network interface message queue
									// Use value of type 'NI_Queue'
    	unsigned char q_cmd : 4;	// Network interface command with queue
									// Use value of type 'NI_QueueCmd'
	   	unsigned char length;		// Length of the buffer to follow
    } q;							// Queue option
    struct {
    	unsigned char cmd;			// Network interface command w/o queue
									// Use value of type 'NI_NoQueueCmd'
      	unsigned char length;		// Length of the buffer to follow
    } noq;							// No queue option
  } ni_hdr;

    unsigned char tag       : 4;	// Message tag for implicit addressing
									// Magic cookie for explicit addressing
    unsigned char auth      : 1;    // 1 => Authenticated
    unsigned char st        : 2;    // Service Type - see 'ServiceType'
    unsigned char msg_type  : 1;    // 0 => explicit message
									//      or unprocessed NV
//---------------------------------------------------------------------------
    unsigned char response  : 1;    // 1 => Response, 0 => Other
    unsigned char pool      : 1;    // 0 => Outgoing
    unsigned char alt_path  : 1;    // 1 => Use path specified in 'path'
									// 0 => Use default path
    unsigned char addr_mode : 1;    // 1 => Explicit addressing,
									// 0 => Implicit
									// Outgoing buffers only
    unsigned char cmpl_code : 2;    // Completion Code - see 'ComplType'
    unsigned char path      : 1;	// 1 => Use alternate path,
									// 0 => Use primary path
									//      (if 'alt_path' is set)
    unsigned char priority  : 1;    // 1 => Priority message 
//---------------------------------------------------------------------------
    unsigned char length;			// Length of msg or NV to follow
									// not including any explicit address
									// field, includes code byte or
									// selector bytes
//---------------------------------------------------------------------------
	unsigned char ExpAddr[11];
//---------------------------------------------------------------------------
	ExplicitMsg _data;

} ExpMsgBuf;

/*****************************************************************************/

#define NI_NO_DATA  	0
#define NI_MSG_AVAIL    1
#define NI_CMD_AVAIL    2

/*
void		ni_reset		(NI_DATA *niData);
void		ni_mip_init		(NI_DATA *niData, char node, char subnet, char domain);
void		ni_flush_cancel	(NI_DATA *niData);

void		ni_msg_send		(NI_DATA *niData);
int			ni_msg_receive	(NI_DATA *niData);
void		ni_clear_status	(NI_DATA *niData);
void		ni_msg_hdr_init	(NI_DATA *niData, unsigned char);
*/
/*****************************************************************************/
