/********************************************
* Dateiname  : NodeStatus.h                 *
*                                           *
* Erstellt   : 23.05.2003                   *
* gendert   : 23.05.2003                   *
*                                           *
* login      : ingo                         *
*                                           *
* Author     : Ingo Grothues                *
*                                           *
* Funktion   : QueryStatus Codes+Structs    *
*                                           *
********************************************/

typedef struct _ND_query_status_response {
	union
	{
		struct
		{
			unsigned short xmit_errors; 		// offset 0x00		BIG ENDIAN !
			unsigned short transaction_timeouts; // offset 0x02		BIG ENDIAN !
			unsigned short rcv_transaction_full; // offset 0x04		BIG ENDIAN !
			unsigned short lost_msgs; 			// offset 0x06		BIG ENDIAN !
			unsigned short missed_msgs; 		// offset 0x08		BIG ENDIAN !
			unsigned char reset_cause; 			// offset 0x0A
			unsigned char node_state;			// offset 0x0B
			unsigned char version_number; 		// offset 0x0C
			unsigned char error_log;			// offset 0x0D
			unsigned char model_number; 			// offset 0x0E
		} expl;

		unsigned char	buf[15];
	};
} ND_query_status_response;

/*
typedef struct _ND_query_status_resp {
	union _header {
		struct {
 		 BYTE	svc_tag;			// 0[7] Service[6..5] auth[4]   tag[3..0]
 		 BYTE	flags;				// prio path cplcode[5..4] expl altp pool resp
 		 BYTE	data_len;
		} header;
		// struct _ND_query_status_response;
		ND_query_status_response x;
	};
} ND_query_status_resp;
*/


/*
	enum {
		no_error = 0,
		bad_event = 129,
		nv_length_mismatch = 130,
		nv_msg_too_short = 131,
		eeprom_write_fail = 132,
		bad_address_type = 133,
		preemption_mode_timeout = 134,
		already_preempted = 135,
		sync_nv_update_lost = 136,
		invalid_resp_alloc = 137,
		invalid_domain = 138,
		read_past_end_of_msg = 139,
		write_past_end_of_msg = 140,
		invalid_addr_table_index = 141,
		incomplete_msg = 142,
		nv_update_on_output_nv = 143,
		no_msg_avail = 144,
		illegal_send = 145,
		unknown_PDU = 146,
		invalid_nv_index = 147,
		divide_by_zero = 148,
		invalid_appl_error = 149,
		memory_alloc_failure = 150,
		write_past_end_of_net_buffer = 151,
		appl_cs_error = 152,
		cnfg_cs_error = 153,
		invalid_xcvr_reg_addr = 154,
		xcvr_reg_timeout = 155,
		write_past_end_of_appl_buffer = 156,
		io_ready = 157,
		self_test_failed = 158,
		subnet_router = 159,
		Authentication_mismatch = 160,
		self_inst_semaphore_set = 161,
		read_write_semaphore_set = 162,
		appl_signature_bad = 163,
		router_firmware_version_mismatch = 164,
	} error_log;
*/

const char* reset_cause_str[] =
{
	"cleared",
	"power-up reset",
	"external reset",
	"watchdog reset",
	"software reset",
	"unknown"
};


const char* err_log_str[] =
{
	"no_error", // = 0,
	"bad_event", // = 129,
	"nv_length_mismatch", // = 130,
	"nv_msg_too_short", // = 131,
	"eeprom_write_fail", // = 132,
	"bad_address_type", // = 133,
	"preemption_mode_timeout", // = 134,
	"already_preempted", // = 135,
	"sync_nv_update_lost", // = 136,
	"invalid_resp_alloc", // = 137,
	"invalid_domain", // = 138,
	"read_past_end_of_msg", // = 139,
	"write_past_end_of_msg", // = 140,
	"invalid_addr_table_index", // = 141,
	"incomplete_msg", // = 142,
	"nv_update_on_output_nv", // = 143,
	"no_msg_avail", // = 144,
	"illegal_send", // = 145,
	"unknown_PDU", // = 146,
	"invalid_nv_index", // = 147,
	"divide_by_zero", // = 148,
	"invalid_appl_error", // = 149,
	"memory_alloc_failure", // = 150,
	"write_past_end_of_net_buffer", // = 151,
	"appl_cs_error", // = 152,
	"cnfg_cs_error", // = 153,
	"invalid_xcvr_reg_addr", // = 154,
	"xcvr_reg_timeout", // = 155,
	"write_past_end_of_appl_buffer", // = 156,
	"io_ready", // = 157,
	"self_test_failed", // = 158,
	"subnet_router", // = 159,
	"Authentication_mismatch", // = 160,
	"self_inst_semaphore_set", // = 161,
	"read_write_semaphore_set", // = 162,
	"appl_signature_bad", // = 163,
	"router_firmware_version_mismatch" // = 164,
};


