//////////////////////////////////////////////////////////////////////
//
// XIF.h:  XIF file decoding
//
// THIS CODE AND INFORMATION IS PROVIDED "AS IS" WITHOUT WARRANTY OF
// ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO
// THE IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
// PARTICULAR PURPOSE.
// Copyright (c) 2000  Gesytec GmbH
//
// Date:   12.01.00
//
// Author: mb, mboehlke@gesytec.de
//
//////////////////////////////////////////////////////////////////////

#ifndef XIF_H
#define XIF_H

#include "ni_host.h"

class CDefFile;

//---------------------------------------------------------------------------

class CXIF 
{
public:
	CXIF	();		
	~CXIF	(void);

	bool	OpenXIF		(void);
	bool	ReadHead	(short pass);
	bool	ReadNV		(short pass, short nvind);
	void	SetSnvtP	(BYTE *psnvt, WORD max);

protected:
	bool	ReadLine		(void);
	bool	snvtAddByte		(BYTE b);
	void	snvtRemByte		(void);
	bool	snvtAddString	(char *s);
	int		snvtDescBit		(short nr);
	short	getShort		(short nr);

public:
	BYTE				mSig[2];
	BYTE				mPid[8];
	int					mNvs;
	int					mTags;
	int					mSNVTLen;

	char				mNVName[17];
	char				mNVDoc[64];
	short				mNVLength;
	short				mNVDir;
	short				mNVService;
	snvt_desc_struct	mNVDesc;

protected:
	CDefFile	*mDef;
	char		*mStart;
	BYTE		*mSnvtStart;
	BYTE		*mSnvtPut;
	BYTE		*mSnvtMax;
	char		mLine[256];
};

//---------------------------------------------------------------------------
#endif // XIF_H
