
#define ID_ALIVE            0x00
#define ID_CONNECT          0x01
#define ID_WINDOW_SIZE      0x02
#define ID_ALIVE_TIMEOUT    0x03
#define ID_LON              0x10
#define ID_CTRL_REQUEST     0x11
#define ID_CTRL_RESPOND     0x12

#define ALIVE_TIMEOUT           5   // 5 s
#define MAX_READ_NOALIVE_COUNT  4
#define MAX_WRITE_ALIVE_COUNT   2

#define MAX_FRAME_LEN	257

typedef struct _IP_MESSAGE_HEADER {
    WORD    Id;
    WORD    Len;
    } IP_MESSAGE_HEADER, *PIP_MESSAGE_HEADER;
#define IP_MESSAGE_HEADER_SIZE sizeof(IP_MESSAGE_HEADER)

typedef struct _IP_MESSAGE {
    IP_MESSAGE_HEADER   h;
    UCHAR               Msg[512];
    } IP_MESSAGE, *PIP_MESSAGE;

typedef struct _IP_WINDOW_SIZE {
    IP_MESSAGE_HEADER   h;
    LONG                WindowSize; // max. No of messages to send
    } IP_WINDOW_SIZE, *PIP_WINDOW_SIZE;

typedef struct _IP_ALIVE_TIMEOUT {
    IP_MESSAGE_HEADER   h;
    DWORD               AliveTimeout; // change default value of ALIVE_TIMEOUT
    } IP_ALIVE_TIMEOUT, *PIP_ALIVE_TIMEOUT;
