/********************************************
* Dateiname  : main.cpp                     *
*                                           *
* Erstellt   : 05.03.2003                   *
* geaendert  : 15.05.2003                   *
*                                           *
* login      : ingo                         *
*                                           *
* Author     : Ingo Grothues                *
*                                           *
* Funktion   : Testprogramm fuer LON-API    *
*                                           *
********************************************/
#include "windows_compat.h"

#include <iostream>
#include <string>

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>

#include <termios.h>
#include <signal.h>
#include <errno.h>
#include <string.h>
#include "g2Lon.h"
#include "ni_host.h"
#include "Utils.h"

#include "ni_privat.h"
#include "NodeStatus.h"
#include "ethernet.h"

	CNet 		NETWORK;
	CNeuron* 	localDevice;
	int 		known_devs;
	struct termios saved_attributes;	// saved Terminal-Settings

	int debugmode;
	int Alive_Timeout_Init = ALIVE_TIMEOUT;

#include "main_functions.cpp"



void exit_app()
{
	tcsetattr (STDIN_FILENO, TCSANOW, &saved_attributes);
	fprintf(stdout, "\n\nClosing Network-Driver.\n");
	NETWORK.Close();
	fprintf(stdout, "Exiting now...\n\n");
	exit(0);
}


int main(int argc, char **argv)
{
    const char *DevName = "/dev/lon/lppdrv0";
    const char *service = "49152";
	known_devs = 0;

	set_input_mode();
	atexit(exit_app);

    int ch, errflg = 0;

    while ((ch = getopt(argc, argv, "d:p:t:")) != EOF)
        switch (ch)
        {
        case 'p':
            service = optarg;
            break;
        case 'd':
            debugmode = atoi(optarg);
            //if (debugmode > MAX_DEBUG_LEVEL)    print_usage_exit();
            if (debugmode > 0)                  fprintf(stderr, "Setting debuglevel to %i\n", debugmode);
            break;
        case 't':
        	Alive_Timeout_Init = atoi(optarg);
            break;
        case '?':
            errflg++;
        }
    if (errflg || optind >= argc)
        {
        //print_usage_exit();
        return -1;
        }
    if (optind < argc)
        {
        DevName = argv[optind++];
        }
    if (optind < argc)
        {
        service = argv[optind];
        }

	if(!init_network(DevName))
	{
		// Treiber nicht geladen:  kein lpclinux-eintrag in lsmod
		// Treiber geladen, bereit:    lpclinux                6528   0
		// Treiber geladen, besetzt:    lpclinux                6528   2
		fprintf(stdout, "Could not open network driver.\n Maybe the driver is not loaded or the device is in use.\n Exiting now...\n\n");
		exit(1);
	}

	print_menu();

	while(true)
	{
		char c = input_loop();

		if (c == '1')
		{
			scan_network();
			fprintf(stdout, "\n");
			print_menu();
		}
		else if (c == '2')
		{
			add_nid();
			fprintf(stdout, "\n");
			print_menu();
		}
		else if (c == '3')
		{
			fprintf(stdout, "\n");
			list_devices(false);
			fprintf(stdout, "\n");
			print_menu();
		}
		else if (c == '4')
		{
			send_message();
			fprintf(stdout, "\n");
			print_menu();
		}
		else if (c == '5')
		{
			upd_domain();
			fprintf(stdout, "\n");
			print_menu();
		}
		else if (c == '6')
		{
			setget_status();
			fprintf(stdout, "\n");
			print_menu();
		}
		else if (c == '7')
		{
			edit_NVs();
			fprintf(stdout, "\n");
			print_menu();
		}
		else if (c == '8')
		{
			edit_NVconfig();
			fprintf(stdout, "\n");
			print_menu();
		}
		else if (c == '9')
		{
			edit_ADTBLs();
			fprintf(stdout, "\n");
			print_menu();
		}
		else if (c == '0')
		{
			raw_tcpip(DevName, service);
			fprintf(stdout, "\n");
			print_menu();
		}
		else if (c == 'x' || c == 'q')
		{
			exit(0);
		}
	}
}
