
#ifndef NI_HOST_H
#define NI_HOST_H
//#pragma pack( push )
//#pragma pack( 1 )					// !!! one byte alignments !!! 
//***************************************************************************

#define		APPL_OFFLINE		0
#define		APPL_ONLINE			1
#define		APPL_RESET			2
#define		CHANGE_STATE		3

#define		APPL_UNCNFG			2
#define		NO_APPL_UNCNFG		3
#define		CNFG_ONLINE			4
#define		CNFG_OFFLINE		6
#define		SOFT_OFFLINE	   12

//---------------------------------------------------------------------------

#define		NEURON_ID_LEN		6
#define		ID_STR_LEN			8
#define		AUTH_KEY_LEN		6
#define		DOMAIN_ID_LEN		6
#define		LOCATION_LEN		6
#define		NUM_COMM_PARAMS		7
#define		MAX_NVS			   62

typedef struct {                                   	// intel endian
	unsigned char	neuron_id[NEURON_ID_LEN];		//	00

	unsigned char	model_num;						//	06

	unsigned char	minor_model_num		: 4;		//	07
	unsigned char						: 4;

	unsigned short	p_nv_fixed;						//	08

 	unsigned char	nv_count			: 6;		//  0A
 	unsigned char						: 1;
 	unsigned char	read_write_protect	: 1;

	unsigned short	p_snvt;							//	0B

	unsigned char	id_string[ID_STR_LEN];			//	0D not for Echelon certified node !!

	unsigned char						: 5;
	unsigned char	explicit_addr		: 1;
	unsigned char	two_domains			: 1;
	unsigned char	NV_processing_off	: 1;

	unsigned char						: 4;
	unsigned char	address_count		: 4;

	unsigned char	receive_trans_count	: 4;
	unsigned char						: 4;

	unsigned char	app_buf_in_size		: 4;
	unsigned char	app_buf_out_size	: 4;

	unsigned char	net_buf_in_size		: 4;
	unsigned char	net_buf_out_size	: 4;

	unsigned char	app_buf_in_priority_count	: 4;
	unsigned char	app_buf_out_priority_count	: 4;

	unsigned char	app_buf_in_count	: 4;
	unsigned char	app_buf_out_count	: 4;

	unsigned char	net_buf_in_count	: 4;
	unsigned char	net_buf_out_count	: 4;
} read_only_data;


typedef struct {
	unsigned char	id[DOMAIN_ID_LEN];
	unsigned char	subnet;
	unsigned char	cl_dom				: 1;
	unsigned char	node				: 7;
	unsigned char	len;
	unsigned char	key[AUTH_KEY_LEN];
} domain_struct;

/*
typedef struct {
	unsigned short	length;
	short			num_netvars;           			// nicht char !!!!
	unsigned char	version;
	unsigned char	mtag_count;
} snvt_struct;
*/
typedef struct {
	unsigned short	channel_id;
	unsigned char	location[LOCATION_LEN];
	unsigned char	comm_clock			: 5;
	unsigned char	input_clock			: 3;
	unsigned char	comm_type			: 3;
	unsigned char	comm_pin_dir		: 5;
	unsigned char	reserved[5];
	unsigned char	node_priority;
	unsigned char	channel_priorities;
	unsigned char	xcvr_params[NUM_COMM_PARAMS];	// union fehlt noch !!
	unsigned char	non_group_timer		: 4;
	unsigned char	nm_auth				: 1;
	unsigned char	preemption_timeout	: 3;
} config_data_struct;

//---------------------------------------------------------------------------

typedef struct {
	unsigned char	nv_selector_hi 		: 6;          	// intel endian
	unsigned char	nv_direction		: 1;
	unsigned char	nv_priority			: 1;

	unsigned char	nv_selector_lo		: 8;

	unsigned char	nv_addr_index 		: 4;
	unsigned char	nv_auth 			: 1;
	unsigned char	nv_service			: 2;
	unsigned char	nv_turnaround 		: 1;
} nv_struct;

typedef struct {                                 		// intel endian
	unsigned char	nv_length			: 5;
	unsigned char	nv_dir				: 2;
	unsigned char	nv_sync				: 1;
	unsigned short	p_nv_address;
} nv_fixed_struct;

typedef struct {                                      	// intel endian
	unsigned char	nv_config_class			: 1;
	unsigned char	nv_auth_config			: 1;
	unsigned char	nv_priority_config		: 1;
	unsigned char	nv_service_type_config	: 1;
	unsigned char	nv_offline				: 1;
	unsigned char	nv_polled				: 1;
	unsigned char	nv_sync					: 1;
	unsigned char	ext_rec					: 1;
	unsigned char	snvt_type_index;
} snvt_desc_struct;

typedef struct {                                    	// intel endian
	unsigned char	type;
	unsigned char	member_or_node			: 7;
	unsigned char	domain					: 1;
	unsigned char	retry					: 4;
	unsigned char	rpt_timer				: 4;
	unsigned char	tx_timer				: 4;
	unsigned char	rcv_timer				: 4;
	unsigned char	group_or_subnet;
} addr_struct;

//---------------------------------------------------------------------------

typedef struct {                                		// intel endian
	unsigned char free		: 3;
	unsigned char nc		: 1;
    unsigned char sd		: 1;    // 
    unsigned char nm		: 1;    // 
    unsigned char re		: 1;    // 
    unsigned char mre		: 1;    // 
} STER;	// SNVT Table Extension Record

//***************************************************************************
//#pragma pack( pop )
#endif
