/*
 *	      NI_MGMT.C - Copyright (c) 1992 Echelon Corporation
 *
 * Last revision: 5/10/92	       Konvertierung C51 08.10.92 g.w.
 *
 * Network management codes and messages.  This file contains a subset
 * of the network management structures defined in the NETMGMT.H file
 * included with the LONBUILDER software.  The types have been changed
 * where necessary because of the difference in sizes between NEURON C
 * ints and PC ints.
 */

#define ID_STR_LEN 			8

typedef enum {
    NM_ABSOLUTE = 0, 
    READ_ONLY_RELATIVE,
    CONFIG_RELATIVE,
    STATS_RELATIVE 
} NM_MODE;

typedef struct {
    unsigned char _code;
    unsigned char neuron_id[NEURON_ID_LEN];
    unsigned char id_string[ID_STR_LEN];
} NM_service_pin_msg;

#define NM_service_pin		0x7F

typedef struct {
    unsigned char _code;
    unsigned char addr_index;
    SendAddrDtl   address;
} NM_update_addr_request;

#define NM_update_addr		0x66

typedef struct {
    unsigned char _code;
    SendGroup	  group_addr;
} NM_update_group_addr_request;

#define NM_update_group_addr 0x69

#define DOMAIN_ID_LEN	6
#define AUTH_KEY_LEN	6

typedef struct {
    unsigned char _code;
    unsigned char domain_index;
    unsigned char id[DOMAIN_ID_LEN];
    unsigned char subnet;
    unsigned char node	      : 7;
    unsigned char must_be_one : 1;
    unsigned char len;
    unsigned char key[AUTH_KEY_LEN];
} NM_update_domain_request;

#define NM_update_domain 0x63

typedef struct {
    unsigned char _code;
    unsigned char nv_index;
    unsigned char nv_selector_hi : 6;
    unsigned char nv_direction	 : 1;
    unsigned char nv_priority	 : 1;
    unsigned char nv_selector_lo : 8;
    unsigned char nv_addr_index  : 4;
    unsigned char nv_auth	 	 : 1;
    unsigned char nv_service	 : 2;
    unsigned char nv_turnaround  : 1;
} NM_update_nv_cnfg_request;

#define NM_update_nv_cnfg 0x6B

/*
typedef enum {
    APPL_UNCNFG    = 2,
    NO_APPL_UNCNFG = 3,
    CNFG_ONLINE    = 4,
    CNFG_OFFLINE   = 6, 	    // Hard offline state	
    SOFT_OFFLINE   = 0xC
} nm_node_state;
*/

typedef struct {
    unsigned char _code;
    unsigned int  xmit_errors;		// !!! Daten sind big endian !!!
    unsigned int  transaction_timeouts; // !!! Daten sind big endian !!!
    unsigned int  rcv_transaction_full; // !!! Daten sind big endian !!!
    unsigned int  lost_msgs;		// !!! Daten sind big endian !!!
    unsigned int  missed_msgs;		// !!! Daten sind big endian !!!
    unsigned char reset_cause;
    unsigned char node_state;	    // Interpret with 'nm_node_state' 
    unsigned char version_number;
    unsigned char error_log;
    unsigned char model_number;
} ND_query_status_response;

#define ND_query_status	0x51
#define ND_clear_status 0x53

typedef enum{
    ST_OFF  = 0,
    ST_LOW  = 1,
    ST_MED  = 2,
    ST_HIGH = 3,
    ST_ON   = 4
} SNVT_lev_disc;

typedef enum{
	MODE_OFF = 0,
	MODE_ON  = 1
} NM_respond_to_query_request;

typedef enum{
	UNCONFIGURED	= 0,
	SELECTED		= 1,
	SELECTED_UNCNFG = 2
} NM_selector_to_query_id;

