
#include "windows_compat.h"
#include "Utils.h"
//#include "stdafx.h"

#include <ctype.h>
#include <pthread.h>
#include <stdio.h>		// fuer stderr, fprintf(), fopen(), fget(), popen(), perror(), ...
#include <string.h>

#define CR	0x0D
#define LF	0x0A

//***************************************************************************
// convert char to TCHAR string
void C2T(TCHAR *a, char *b, int l)
{
	TCHAR *t = a;
	while (*b && (l > 0)) { *a++ = (TCHAR)*b++; l--; }
	*a = 0;
}

// convert char* to TCHAR*, return length, limit to l chars if > 0
int c2t(TCHAR *ptStr, char *pStr, int l)
{
   int i = 0;
   if (l > 0)
      while (*pStr && (l > 0)) { *ptStr++ = (TCHAR)*pStr++; l--; i++; }
   else
      while (*pStr) { *ptStr++ = (TCHAR)*pStr++; i++; }
   *ptStr = 0;
   return i;
}

// convert TCHAR to char string, limit to l chars if > 0
void T2C(char *a, TCHAR *b, int l)
{
	char *t = a;

	if (l > 0)
	   while (*b && (l > 0)) { *a++ = (char)*b++; l--; }
	else
		while (*b) { *a++ = (char)*b++; }
	*a = 0;  // add \0 char
}


// convert TCHAR* to char*, limit to l chars if > 0
int t2c(char *pStr, TCHAR *ptStr, int l)
{
   int i = 0;
   if (l > 0)
      while (*ptStr && (l > 0)) { *pStr++ = (char)*ptStr++; l--; i++; }
   else
      while (*ptStr) { *pStr++ = (char)*ptStr++; i++; }
   *pStr = 0;
   return i;
}

//---------------------------------------------------------------------------

bool streq(char *a, char *b)			// just a shortcut
{
	return (!strcmp(a, b));
}

//---------------------------------------------------------------------------

bool strieq(char *a, char *b)			// case insensitive compare
{
	if (strlen(a) != strlen(b))			return (false);
	while (*a) {
		if (toupper(*a) != toupper(*b)) return (false);
		a++; b++;
	}
	return (true);
}

//---------------------------------------------------------------------------

bool strnieq(char *a, char *b, short n)	// case insensitive compare
{
	while (n--) {
		if (toupper(*a) != toupper(*b)) return (false);
		a++; b++;
	}
	return (true);
}

//---------------------------------------------------------------------------

void setString(char **dp, char *sp)
{
	if (*dp) delete *dp;
	if (sp) {
		*dp = new char [strlen(sp) +1];
		strcpy(*dp, sp);
	}
	else {
		*dp = NULL;
	}
}

//---------------------------------------------------------------------------

bool inStr(char c, char *str)
{
	while (*str) {
		if (*str++ == c) return (true);
	}
	return (false);
}

//---------------------------------------------------------------------------

bool my_strcpy(char *dp, unsigned short max, char *sp)
{
	if (strlen(sp) >= max) return (false);
	strcpy(dp, sp);
	return (true);
}

char *my_strcpy(char *dp, char *sp)
// returns pointer to the end of the copied string
{
	while (*sp) *dp++ = *sp++;
	*dp = 0;
	return (dp);
}

char *my_strncpy(char *dp, char *sp, short n)
// copy max n chars including the zero at the end
// returns pointer to the end of the copied string
// Achtung: fuer n ist die Angabe sizeof(buf) gedacht   !!!!!!!
//	wenn man n chars kopieren will muss man n+1 angeben !!!!!!!
{
	if (n <= 0) return (dp);
	while (*sp && --n) *dp++ = *sp++;
	*dp = 0;
	return (dp);
}

//---------------------------------------------------------------------------

char *hexdump(char *dp, BYTE *sp, short n, char sep)
{
	char	c, h;

	while (n--)
	{
	 	c = *sp++;						// aktuelles Zeichen

	 	h = (c >> 4) & 0xF;				// Bits 4..7
	 	if (h <= 9) *dp++ = h + 0x30;	// Ziffer als 0-9 ausgeben
	 	else		*dp++ = h + 0x37; 	// Ziffer als A-F ausgeben

	 	h = c & 0xF;					// Bits 0..3
	 	if (h <= 9) *dp++ = h + 0x30;	// Ziffer als 0-9 ausgeben
	 	else		*dp++ = h + 0x37;	// Ziffer als A-F ausgeben

	 	if (sep) 	*dp++ = sep; 		// ggfs. Trennzeichen einfuegen
	}
	*dp = 0;		// terminieren
	return (dp);
}

//---------------------------------------------------------------------------

char *readable(char *dp, char *sp, short n)
{
	char c;
	short i;
	for (i = 0; i < n; i++) {
		if (!(c = sp[i])) break;
		if ((c < 0x20) || (c & 0x80))
			return (hexdump(dp, (BYTE *)sp, n, 0));
		dp[i] = c;
	}
	dp[i] = 0;
	return (dp);
}

//---------------------------------------------------------------------------

char *findtoken(char *sp, short n, char tok)
{
	char	c;
	while (n--) {							// skip over tokens
		while (c = *sp) {
			sp++;
			if (c == tok) break;
		}
	}
	return (sp);
}

//---------------------------------------------------------------------------

short gettoken(char *dp, short max, char *sp, char tok)
{
	short len = cpytoken(dp, max, sp, 0, tok);
	cpyright(sp, 999, sp, 1, tok);
	return (len);
}

//---------------------------------------------------------------------------

short cpytoken(char *dp, short max, char *sp, short n, char tok)
// we copy the nte token and return the length of it
//	(we never skip the source pointer over the terminating zero)
{
	char	c;
	short	len = 0;

	sp = findtoken(sp, n, tok);						// skip over tokens
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	while (c = *sp) {
		sp++;
		if (c == tok) break;
		len++;
		if (len >= max) { *dp = 0; return (-1);	}	// not enough space
		*dp++ = c;
	}
	*dp = 0;
	return (len);
}

//---------------------------------------------------------------------------

short cpyright(char *dp, short max, char *sp, short n, char tok)
{
	char	c;
	short	len = 0;

	sp = findtoken(sp, n, tok);				// skip over tokens
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
	*dp = 0;								// clear dest string
	while (c = *sp++) {
		len++;
		if (len >= max) return (-1);		// not enough space
		*dp++ = c;
		*dp   = 0;
	}
	return (len);
}

//---------------------------------------------------------------------------

bool isInt(char *str)
{
	char	c;
	short	len = 0;

	if (!str) return (false);
	if		(*str == '-') str++;
	else if (*str == '+') str++;

	while (c = *str++) {
		len++;
   		if (c < '0') return (false);
		if (c > '9') return (false);
    }
   	return (true);
}

//---------------------------------------------------------------------------

bool chkHex(char *str, short count)
{
	char	c;
    while (count--) {
		c = *str++;
		if (c <  '0') return (false);
		if (c <= '9') continue;
		if (c <  'A') return (false);
		if (c <= 'F') continue;
		if (c <  'a') return (false);
		if (c >  'f') return (false);
    }
   	return (true);
}

//---------------------------------------------------------------------------

char nib2bin(char c)
{
	char	v;

	v = c - '0';
	if (v <= 9) return (v);
	v -= 7;
	if (v <= 15) return (v);
	v = c - 'a' + 10;
	return (v);
}

void htobin(char *str, BYTE *bin)
{
	int		len, ind;
	char	c;
	BOOL	upper;

    ind = 0;
	len = strlen(str);
    upper = TRUE;
    while (ind < len) {
		c = nib2bin(str[ind++]);
		if (upper) {
			*bin  = c << 4;
			upper = FALSE;
		}
		else {
			*bin++  += c;
			upper = TRUE;
		}
    }
}

//---------------------------------------------------------------------------

bool CreateThread(LPVOID func, LPVOID par)
{
	// Thread_attr erstellen
	pthread_attr_t attr;
    pthread_attr_init(&attr);
    pthread_attr_setscope(&attr, PTHREAD_SCOPE_SYSTEM);
	pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED);

	pthread_t m_thread;
   	if(pthread_create(&m_thread, &attr, (LPTHREAD_START_ROUTINE)func, par) != 0)
   	{
   		perror("CreateThread failed\r\n");
		return (false);
	}
	pthread_attr_destroy(&attr);			// Thread_attr loeschen
	return (true);

/*	DWORD iThread = 0;
	HANDLE m_thread = CreateThread(NULL, 0,
							(LPTHREAD_START_ROUTINE)func,
							par, 0, &iThread);
	if (m_thread == NULL) {
		RETAILMSG(1, (TEXT("CreateThread failed\r\n")));
		return (false);
	}

	CloseHandle(m_thread);
	return (true);
*/
}

//---------------------------------------------------------------------------
/*
bool sprintfTime(char *buf, FILETIME *ft)
{
	SYSTEMTIME st;
	*buf = 0;
	if (!FileTimeToSystemTime(ft, &st)) return (false);

	sprintf(buf, "%04d.%02d.%02d.%02d.%02d.%02d",
		st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond);
	return (true);
}
*/
//---------------------------------------------------------------------------
/*
BYTE *valPtr(LPVARIANT v, short *len)
{
	if (v->vt == VT_BOOL) {
		*len = 2;
		return ((BYTE *)&v->boolVal);
	}

	if (v->vt == VT_UI1) {
		*len = 1;
		return (&v->bVal);
	}

   if (v->vt == VT_I2) {
		*len = 2;
		return ((BYTE *)&v->iVal);
	}

	if (v->vt == VT_I4) {
		*len = 4;
		return ((BYTE *)&v->lVal);
	}

	if (v->vt == VT_R4) {
		*len = 4;
		return ((BYTE *)&v->fltVal);
	}

	*len = 0;
	return (NULL);
}
*/
//---------------------------------------------------------------------------
/*
bool setVal(LPVARIANT v, VARTYPE vt, BYTE *data, short len)
{
	v->vt = vt;

	if (vt == VT_BOOL) {
		v->boolVal = *((short *)data);
		return (true);
	}

	if (vt == VT_UI1) {
		v->bVal = *data;
		return (true);
	}

   if (vt == VT_I2) {
		v->iVal = *((short *)data);
		return (true);
	}

	if (vt == VT_I4) {
		v->lVal = *((long *)data);
		return (true);
	}

	if (vt == VT_R4) {
		v->fltVal = *((float *)data);
		return (true);
	}

	v->vt = VT_EMPTY;
	return (false);
}
*/


//	Zeichenkette aus laenge Ziffern als unsigned int zuueckgeben (rn, 21.02.00)
//---------------------------------------------------------------------------
unsigned long String2Int (char *text, int laenge)
{
	int j;
	int k;
	unsigned long x;
	unsigned long y = 0;

	for (k=0; k < laenge; k++)
	{
		x = (unsigned int) (text[k]-'0');
		for (j=0; j < laenge -k-1; j++)
			x *= 10;
		y += x;
	}
	return y;
}



//***************************************************************************
bool CLockCrit::allow2ndLock	= false;

CLockCrit::CLockCrit(CRITICAL_SECTION *hdl)
{
	mHdl = hdl;
	if (debugmode & 0x10)  fprintf(stderr, "CLockCrit(%p)\n", mHdl);

	if(!allow2ndLock) EnterCriticalSection(mHdl);

	allow2ndLock = false;
}

//***************************************************************************

CLockCrit::CLockCrit(CRITICAL_SECTION *hdl, int flag)
{
	mHdl = hdl;
	if (debugmode & 0x10)  fprintf(stderr, "CLockCrit(%p, allow2ndLock)\n", mHdl);
	allow2ndLock = true;
	EnterCriticalSection(mHdl);
/*
	int retval = TryCriticalSection(mHdl);

	if(retval != 0)
	{
		 fprintf(stderr, "already locked !\n");
		 alreadylocked = true;
	}
	else
	{
		 fprintf(stderr, "not locked !\n");
		 alreadylocked = false;
	}
*/
}

//---------------------------------------------------------------------------

CLockCrit::~CLockCrit()
{
	if (debugmode & 0x10)  fprintf(stderr, "~CLockCrit(%p)\n", mHdl);
	if(allow2ndLock)
	{
		if (debugmode & 0x10)  fprintf(stderr, "~CLockCrit(%p): allow2ndLock was still TRUE !\n", mHdl);
	}
	allow2ndLock = false;
	LeaveCriticalSection(mHdl);
}

//***************************************************************************
/*
CLockMut::CLockMut(HANDLE hdl)
{
	mHdl = hdl;
	DWORD dwWaitResult = WaitForSingleObject(
         mHdl,				// handle of mutex
         5000L);			// five-second time-out interval

	if (dwWaitResult == WAIT_FAILED) {
		perror("CLockMut: getMutex WAIT_FAILED\r\n");
		//RETAILMSG(1, (TEXT("CLockMut: getMutex WAIT_FAILED\r\n")));
		return;
	}

	if (dwWaitResult == WAIT_OBJECT_0) return;

	perror("CLockMut: getMutex FAILED\r\n");
	//RETAILMSG(1, (TEXT("CLockMut: getMutex FAILED\r\n")));
}
*/
//---------------------------------------------------------------------------
/*
CLockMut::~CLockMut()
{
	ReleaseMutex(mHdl);
}
*/
//***************************************************************************
