#ifndef WATCHER_H
#define WATCHER_H
// ---------------------------------------------------------------------------

//#define LONC_API /*/* __declspec(dllexport) */*/

#define CRC_ERR		0x02

//struct LONC_API FLAT {
typedef struct LONC_API {
	_int64	itime;

	BYTE flags;
	BYTE mac;			// Prior, AltPath, Delta_BL

	BYTE version;
	BYTE pfmt;			// PDU format
	BYTE afmt;			// Adr format
	BYTE domlen;		// length of domain 0, 1, 3, 6

	BYTE ssubnet;		// sender subnet
	BYTE snode;			// sender node

	BYTE dnet_grp;		// destination subnet or group
	BYTE dnode[6];		// destination node/neuron id

	BYTE domain[6];		// domain id

	BYTE auth;			// authentication 
	BYTE ptyp;			// PDU type
	BYTE tanr;			// transaction number

	BYTE mlistlen;
	BYTE mlist[8];

	BYTE dlen;			// length of data
	BYTE data[255];		// the transmitted data
//};
} FLAT;

// ---------------------------------------------------------------------------

class CNeuron;
class CNV;

LONC_API bool	W_Init			(void);
LONC_API short	W_GetPacket		(BYTE *packet, DWORD len);
LONC_API short	W_Dec2Flat		(FLAT *flat, BYTE *packet, short len);

LONC_API bool	W_IsSrv_Sent	(FLAT *flat);
LONC_API bool	W_IsNV_Sent		(FLAT *flat);
LONC_API bool	W_IsMsg_Sent	(FLAT *flat);

LONC_API CNV	*W_GetSentNV	(FLAT *flat, CNeuron *neuron);
LONC_API CNV	*W_GetNVbySel	(CNeuron *neuron, WORD sel);

// ---------------------------------------------------------------------------
#endif


