//***************************************************************************

#include "windows_compat.h"
#include "xDbg.h"
#include "Utils.h"
#include "DebugMsg.h"

#include <stdio.h>
#include <string.h>

//static WORD	gXDBG	= 0;  //no Debug
static WORD	gXDBG	= 1;  //all Debug

//***************************************************************************

WORD DBGSET(WORD flag)
{	// not thread save
	WORD ret = gXDBG;
	gXDBG	 = flag;
	return (ret);
}

//---------------------------------------------------------------------------

bool DBG(WORD flag)									// should debug ?
{
	if (flag  & DBG_ALL) return (true);
	if (gXDBG & DBG_ALL) return (true);
	if (gXDBG & flag)	 return (true);

	return (false);
}

//---------------------------------------------------------------------------

void DBG(WORD flag, const char *text)						// print if debug
{
	//if (!DBG(flag)) return;
	DBGERR(text);
}

//---------------------------------------------------------------------------

void DBG(WORD flag, const char *text, void *hex, short n)	// print if debug
{
	if (!DBG(flag)) return;

	char s[1024];
	strcpy(s, text);
	hexdump(&s[strlen(s)], (BYTE *)hex, n, 0);
	DBGERR(s);
}

//---------------------------------------------------------------------------

bool DBGERR(const char *text)								// print always
{
	fprintf(stderr, "%s\r\n", text);
//	RETAILMSG(1, (TEXT("%a\r\n"), text));
//	DEBUGPRINT(1, (PRINTF("%s\r\n"), text));  // DEBUGINIT
	return (false);
}

//***************************************************************************

